#!/bin/bash 
# \
exec tixwish $0 $@
#############################################################################
# Visual Tcl v1.10 Project
#

#################################
# GLOBAL VARIABLES
#
global .top34.fra35.fra37.tix50; 
global .top34.fra35.fra37.tix51; 
global OptionList; 
global Property; 
global Stepsize; 
global downsize; 
global downstep; 
global leftsize; 
global leftstep; 
global nls; 
global nlstype; 
global rightsize; 
global rightstep; 
global upsize; 
global upstep; 
global var; 
global widget; 
    set widget(BtnAbort) {.top34.fra35.fra38.fra45.01.fra47.but48}
    set widget(BtnBack) {.top34.fra35.fra37.fra35.but45}
    set widget(BtnNext) {.top34.fra35.fra37.fra35.but36}
    set widget(BtnPosDown) {.top34.fra35.fra37.tix51.border.frame.fra81.010.011}
    set widget(BtnPosLeft) {.top34.fra35.fra37.tix51.border.frame.fra81.02.03}
    set widget(BtnPosRight) {.top34.fra35.fra37.tix51.border.frame.fra81.08.09}
    set widget(BtnPosUp) {.top34.fra35.fra37.tix51.border.frame.fra81.05.06}
    set widget(BtnPrev) {.top34.fra35.fra37.fra35.but37}
    set widget(BtnReset) {.top34.fra35.fra37.fra35.but38}
    set widget(BtnSave) {.top34.fra35.fra38.fra45.01.fra47.but30}
    set widget(BtnSaveMode) {.top34.fra35.fra37.fra35.but46}
    set widget(BtnSizeDown) {.top34.fra35.fra37.tix50.border.frame.fra52.fra71.but79}
    set widget(BtnSizeLeft) {.top34.fra35.fra37.tix50.border.frame.fra52.fra65.but77}
    set widget(BtnSizeRight) {.top34.fra35.fra37.tix50.border.frame.fra52.fra70.but80}
    set widget(BtnSizeUp) {.top34.fra35.fra37.tix50.border.frame.fra52.fra67.but78}
    set widget(InfoMessage) {.top30.fra31.fra33.mes34}
    set widget(MenuFile) {.top34.fra35.fra36.fra39.fra42.men43}
    set widget(MenuOptions) {.top34.fra35.fra36.fra39.fra42.men47}
    set widget(MenuStepsize) {.top34.fra35.fra36.fra39.fra42.men44}
    set widget(TextInfo) {.top34.fra35.fra38.fra45.01.fra29.tex32}
    set widget(TixlabelPos) {.top34.fra35.fra37.tix51}
    set widget(TixlabelSize) {.top34.fra35.fra37.tix50}
    set widget(TopCurrent) {.top30}
    set widget(Xfine) {.top34}
    set widget(rev,.top30) {TopCurrent}
    set widget(rev,.top30.fra31.fra33.mes34) {InfoMessage}
    set widget(rev,.top34) {Xfine}
    set widget(rev,.top34.fra35.fra36.fra39.fra42.men43) {MenuFile}
    set widget(rev,.top34.fra35.fra36.fra39.fra42.men44) {MenuStepsize}
    set widget(rev,.top34.fra35.fra36.fra39.fra42.men47) {MenuOptions}
    set widget(rev,.top34.fra35.fra37.fra35.but36) {BtnNext}
    set widget(rev,.top34.fra35.fra37.fra35.but37) {BtnPrev}
    set widget(rev,.top34.fra35.fra37.fra35.but38) {BtnReset}
    set widget(rev,.top34.fra35.fra37.fra35.but45) {BtnBack}
    set widget(rev,.top34.fra35.fra37.fra35.but46) {BtnSaveMode}
    set widget(rev,.top34.fra35.fra37.tix50) {TixlabelSize}
    set widget(rev,.top34.fra35.fra37.tix50.border.frame.fra52.fra65.but77) {BtnSizeLeft}
    set widget(rev,.top34.fra35.fra37.tix50.border.frame.fra52.fra67.but78) {BtnSizeUp}
    set widget(rev,.top34.fra35.fra37.tix50.border.frame.fra52.fra70.but80) {BtnSizeRight}
    set widget(rev,.top34.fra35.fra37.tix50.border.frame.fra52.fra71.but79) {BtnSizeDown}
    set widget(rev,.top34.fra35.fra37.tix51) {TixlabelPos}
    set widget(rev,.top34.fra35.fra37.tix51.border.frame.fra81.010.011) {BtnPosDown}
    set widget(rev,.top34.fra35.fra37.tix51.border.frame.fra81.02.03) {BtnPosLeft}
    set widget(rev,.top34.fra35.fra37.tix51.border.frame.fra81.05.06) {BtnPosUp}
    set widget(rev,.top34.fra35.fra37.tix51.border.frame.fra81.08.09) {BtnPosRight}
    set widget(rev,.top34.fra35.fra38.fra45.01.fra29.mes33) {InfoMessage}
    set widget(rev,.top34.fra35.fra38.fra45.01.fra29.mes37) {InfoMessage}
    set widget(rev,.top34.fra35.fra38.fra45.01.fra29.tex32) {TextInfo}
    set widget(rev,.top34.fra35.fra38.fra45.01.fra47.but30) {BtnSave}
    set widget(rev,.top34.fra35.fra38.fra45.01.fra47.but48) {BtnAbort}

#################################
# USER DEFINED PROCEDURES
#
proc GetSavedClock { mode } {
####--GetSavedClock--####
# this function search for the timing parameter in
# the /var/X11R6/sax/tmp/config which belongs to the
# mode called <mode>. If it find this modeline the
# RamDac Value is seperated and returned. We need
# this function because the saved modeline and the
# call Xinfo -m differs a little bit in some cases.
#

 global var

 #-------------------------#
 # get the timings of mode #
 #-------------------------#
 set real_timing [ lrange $mode 2 9 ]

 set handle [ open $var(SaxConfig) "r" ]
 set found "no"
 while { [ eof $handle ] == 0 } {
  set line [ gets $handle ]
  if { [ regexp -- {(.*)Modeline(.*)} $line ] } {
   set line [ string trim $line ]
   set saved_timing [ lrange $line 3 10 ];
   if { $saved_timing == $real_timing } {
    set found "yes"
    close $handle
    return [ lindex $line 2 ]
   }
  }
 }

 close $handle
 return "invalid"
}


proc init {argc argv} {
global var
global widget

set var(PixmapPath) "/var/X11R6/sax/pixmaps/"
set var(Xinfo)      "/var/X11R6/sax/bin/Xinfo"
set var(SaxRc)      "/var/X11R6/sax/config/saxrc"
set var(LangPath)   "/var/X11R6/sax/config/"
set var(lang)       "en"
set var(XfineMode)  "normal"
set var(Changed)    "/tmp/sax/changed"
set var(Xpos)       ""
set var(Ypos)       ""
set var(Hdisp)      ""
set var(Hsyncstart) ""
set var(Hsyncend)   ""
set var(Htotal)     ""
set var(Vdisp)      ""
set var(Vsyncstart) ""
set var(Vtotal)     "" 
set var(Vsyncend)   ""
set var(SaxTmp)        "/tmp/sax/"
set var(XfineReturn)   "/tmp/sax/xfinereturn"
set var(ReturnValue)   ""
set var(UpdateConfig)  "/var/X11R6/sax/bin/UpdateConfig"
set var(ConfigFile)    "/etc/XF86Config"
set var(ConfigOld)     "/etc/XF86Config.saxsave"
set var(SaxConfig)     "/var/X11R6/sax/tmp/config"

global upstep 
global downstep
global leftstep
global rightstep
global upsize 
global downsize
global leftsize
global rightsize

set upstep    "6"
set downstep  "6"
set leftstep  "8"
set rightstep "8"
set upsize    "8" 
set downsize  "8" 
set leftsize  "8"
set rightsize "8" 


#------------#
# read saxrc #
#------------#
set dummy ""
set left  ""
set right ""
set handle [ open $var(SaxRc) "r" ]
set lang [ gets $handle ]
regexp -- {(.*):(.*)} $lang dummy left right
switch $right {
 
 "de"    { set var(lang) "de" }
 "en"    { set var(lang) "en" }
 "fr"    { set var(lang) "fr" }
 "it"    { set var(lang) "it" }
 "es"    { set var(lang) "es" }
 "pt_BR" { set var(lang) "pt_BR" }
 "br"    { set var(lang) "br" }
 "nl"    { set var(lang) "nl" }
 "hu"    { set var(lang) "hu" }
 "pl"    { set var(lang) "pl" }
 "pt"    { set var(lang) "pt" }
 "sk"    { set var(lang) "sk" }
 "ro"    { set var(lang) "ro" }
 "el"    { set var(lang) "el" }
 "id"    { set var(lang) "id" }
 "ru"    { set var(lang) "ru" }
 "tr"    { set var(lang) "tr" }
 "sv"    { set var(lang) "sv" }
 "cs"    { set var(lang) "cs" }
 "ca"    { set var(lang) "ca" } 
 default { set var(lang) "en" }

}
set modi [ gets $handle ]
regexp -- {(.*):(.*)} $modi dummy left right
switch $right {
 
 "normal"     { set var(XfineMode) "normal" }
 "configure"  { set var(XfineMode) "configure" }
 default      { set var(XfineMode) "normal" }

}
close $handle 

#--------------------#
# store actual line  #
#--------------------#
catch { set oldmode [ exec $var(Xinfo) -m ] }
set saved_clock [ GetSavedClock $oldmode ]
if { $saved_clock != "invalid" } {
 if { $saved_clock != [ lindex $oldmode 1 ] } {
  set oldmode [ lreplace $oldmode 1 1 $saved_clock ]
 }
}
set res [ lrange $oldmode 0 0 ]
set res [ string trim $res {"} ]
set res [ string trim $res ]
set var(Old[set res]) $oldmode


#-----------------------#
# set the center values #
#-----------------------#
set modename [ lindex $oldmode 0 ]
set dummy ""
set x     ""
set y     ""
regexp -- {(.*)x(.*)} $modename dummy x y
set var(Xpos) [ expr int ( ( $x - 550 ) / 2.0  ) ]
set var(Ypos) [ expr int ( ( $y - 350 ) / 2.0  ) ]
}

init $argc $argv

proc ProveOnRoot {} {
#--------------#
# variables    #
#--------------#
set ID  "nonroot"

catch { eval { exec whoami > /tmp/user } }
set handle [ open "/tmp/user" "r" ]
gets $handle ID
close $handle
catch { eval { exec rm -f /tmp/user } }
if { $ID != "root" } {
 puts "xfine: only root can do this"
 exit "0"
}
}


proc StoreOldMode {} {
###--StoreOldMode--###
# this function store the current mode as old mode
# to the var array. The naming is var(Old<Resolution>)
#
global var
catch { set oldmode [ exec $var(Xinfo) -m ] }
set saved_clock [ GetSavedClock $oldmode ]
if { $saved_clock != "invalid" } {
 if { $saved_clock != [ lindex $oldmode 1 ] } {
  set oldmode [ lreplace $oldmode 1 1 $saved_clock ]
 }
}

set res [ lrange $oldmode 0 0 ]
set res [ string trim $res {"} ]
set res [ string trim $res ]
set var(Old[set res]) $oldmode
}

proc CalculateFreq {HFL VFL} {
#---------------------------#
# calculate the             #
# frequenzies before apply  #
# to the xserver            #
#---------------------------#
#-------------#
# variables   #
#-------------#
global var

catch { set mode [ exec $var(Xinfo) -m ] }
set DCF [ lindex $mode 1 ]

catch { set Horizontal [ expr $DCF / $HFL.0 ] }
catch { set Vertical   [ expr int ( ( $Horizontal \* 1e6 ) / $VFL ) ] }
catch { set Horizontal [ expr int ( $Horizontal \* 1000 ) ] }

set flist ""
set flist [ linsert $flist end $Horizontal ]
set flist [ linsert $flist end $Vertical   ]
return $flist
}

proc EvaluateMaxFreq {HFL VFL} {
####--EvaluateMaxFreq--#####
# asks the Xserver for the maximum 
# frequenz area
#
#-------------#
# variables   #
#-------------#
global var
set flist   ""
set tmplist ""

catch { set flist [ exec $var(Xinfo) -f ]  }
foreach i $flist {
 set tmplist [ linsert $tmplist end $i ]
}
set flist $tmplist

set minhs [ lindex $flist 0 ]
set maxhs [ lindex $flist 1 ]
set minvs [ lindex $flist 2 ]
set maxvs [ lindex $flist 3 ]

#
# compare actual values with 
# accepting values
#
set actfreq [ CalculateFreq $HFL $VFL ]
set hsact [ lindex $actfreq 0 ]
set vsact [ lindex $actfreq 1 ]
if { $hsact < $minhs } { return -1 }
if { $hsact > $maxhs } { return -1 }
if { $vsact < $minvs } { return -1 }
if { $vsact > $maxvs } { return -1 }
return 0
}

proc GetColorDepth {} {
#-----------------------------------#
# try to find out the color depth   #
#-----------------------------------#
set depth ""
set depth [ exec xdpyinfo | grep "depth of root window:" | cut -f2 -d: | cut -c5-6 ]
return $depth
}

proc GetHdisp {ihdisp ihsyncstart ihsyncend ihtotal} {
#-----------#
# variables #
#-----------#
upvar $ihdisp       hdisp
upvar $ihsyncstart  hsyncstart
upvar $ihsyncend    hsyncend
upvar $ihtotal      htotal
global var

catch { set mode [ exec $var(Xinfo) -m ] }
set count 0
foreach i $mode {
 switch $count {
  
   "2" { set hdisp $i }
   "3" { set hsyncstart $i }
   "4" { set hsyncend $i }
   "5" { set htotal $i }

 }
 incr count
}
}

proc GetOptions {iOptionList} {
#####--GetOptions--#######
# This function read all options
# possible are:
# --lang    id
#

upvar $iOptionList option
global argv

set    argcount     "0"
set    arg          ""
set    option(-l)   ""  
    
    while { 1 } {
        
        set arg [ lindex $argv $argcount ]
        incr argcount
        switch -glob -- "$arg" {
            
            -l             -
            --lang         { 
                
                set arg "-l"
            }
            
            -*           {
                
                puts "error: '$arg' is not a valid option."
                exit -1
            }
            
            default          { break }
        }
        
        #--Save the content of the Option in option 
        
        set option($arg) [ lindex $argv $argcount ]
        incr argcount
        
        if { $option($arg) == "" } {
            
            puts "error: missing parameter to option '$arg'!"
            exit -1
        }
    }
}

proc GetVdisp {ivdisp ivsyncstart ivsyncend ivtotal} {
#-----------#
# variables #
#-----------#
upvar $ivdisp       vdisp
upvar $ivsyncstart  vsyncstart
upvar $ivsyncend    vsyncend
upvar $ivtotal      vtotal
global var

catch { set mode [ exec $var(Xinfo) -m ] }
set count 0
foreach i $mode {
 switch $count {

   "6" { set vdisp $i }
   "7" { set vsyncstart $i }
   "8" { set vsyncend $i }
   "9" { set vtotal $i }

 }
 incr count
}
}

proc InitAllWidgets {} {
#####--InitAllWidgets--#######
# This function set the fonts the geometry 
# and all other settings to some widgets 
#
#-------------#
# Variables   #
#-------------#
global widget
global var
set StdFont   "-*-Helvetica-Medium-R-Normal-*-14-*-*-*-*-*-*-*"
set ListFont  "-*-fixed-medium-*-*-*-13-*-*-*-*-*-*-*"

#
# set the font for the menus
#
set InfoWidgets ""
foreach i [ array names widget ] {
 if [ winfo exists $widget($i) ] {
  set InfoWidgets [ linsert  $InfoWidgets end $widget($i) ]
 }
}

foreach i $InfoWidgets {
  switch [ winfo class $i ] {

        Menubutton -
        Label {
          $i configure  -font $StdFont
        }

  }     
}

foreach mb { MenuOptions MenuStepsize } {

 set m [ $widget($mb) cget -menu ]
 set num [ $m index last ]

 set j 0
 for { set i 0 } { $i <= $num } { incr i } {

  if { [ $m type $i ] == "separator" } {
   continue
  }

  $m entryconfigure $i  -font $StdFont
  incr j
 }

}
}

proc InitNlstext {} {
#####--InitNlstext--#######
# This function read the xfinetext.<language> file
# and creates the "nls" array
#

#----------------#
# Variables      #
#----------------#
global nls 
global var 

if [ file exists "$var(LangPath)/xfinetext.$var(lang)" ] {

 set fd [ open "$var(LangPath)/xfinetext.$var(lang)" r ]
 if { $fd == -1 } {
  return -1
 }

 set buffer {}
 while { [ gets $fd buffer ] != -1 } {

    switch -regexp -- "$buffer" {
                
       {^[ \t]*#.*$} -
       {^[ \t]+$}    {
          continue 
       }
    }
    set buffer [ string trim $buffer ]
    if [ regexp -- {([^         ]+)[    ]+(.*)} $buffer dummy id text ] {

     set text [ string trim $text ]
     eval set nls($var(lang),$id) "$text"
    }
 }

 close $fd
}
}

proc InitNlstype {} {
#####--InitNlstype--#######
# This function set alias names for all widget aliases
# same text have the same alias name ( e.g. cancel )
#

#---------------#
# Variables     #
#---------------#
global nlstype

#-------------#
# types       #
#-------------#
set nlstype(Xfine)           "main_xfine"
set nlstype(TopCurrent)      "top_current"

set nlstype(TixlabelSize)   "size"
set nlstype(TixlabelPos)    "pos"

set nlstype(BtnAbort)       "abort"
set nlstype(BtnSave)        "save"
set nlstype(BtnNext)        "next"
set nlstype(BtnPrev)        "prev"
set nlstype(BtnReset)       "reset"
set nlstype(BtnSaveMode)    "savemode"
set nlstype(BtnBack)        "back"
set nlstype(MenuOptions)    "menu_options"
set nlstype(MenuStepsize)   "menu_stepsize"
}

proc SaveAndExit {} {
#-------------#
# variables   #
#-------------
global var

#-----------------------#
# set new and old mode  #
#-----------------------#
catch { set mode [ exec $var(Xinfo) -m ] }
set res [ lrange $mode 0 0 ]
set res [ string trim $res {"} ]
set res [ string trim $res ]
set file $var(SaxTmp)[set res]
SaveMode $file

#----------------#
# install config #
#----------------#
if { [ file exists $var(ConfigFile) ] } {
 catch { exec cp $var(ConfigFile) $var(ConfigOld) }
}
catch { exec cp $var(SaxConfig) $var(ConfigFile) }

#---------------#
# update config # 
#---------------#
exec $var(UpdateConfig)

#-----------#
# return 3  #
#-----------#
set var(ReturnValue) "3"

set handle [ open $var(XfineReturn) "w" ]
puts $handle $var(ReturnValue)
close $handle

exit 0
}

proc SaveMode {filename} {
#--------------#
# variables    #
#--------------#
global var

catch { set newmode [ exec $var(Xinfo) -m ] }
set res [ lrange $newmode 0 0 ]
set res [ string trim $res {"} ]
set res [ string trim $res ]

set line "$var(Old[set res]):$newmode"
#puts $line

set handle [ open $filename "w" ]
puts $handle $line
close $handle

set found  "no"
set buffer ""
if { [ file exists $var(Changed) ] } {
 set handle [ open $var(Changed) "r" ]
 while { [ eof $handle ] == 0 } {
  gets $handle buffer
  if { $buffer == "$var(SaxTmp)[set res]" } {
   set found "yes"
   break
  }
 } 
 close $handle
}
if { $found == "no" } {
 set handle [ open $var(Changed) "a" ]
 puts $handle "$var(SaxTmp)[set res]"
 close $handle
}
}

proc SetInfo {} {
#-------------#
# variables   #
#-------------#
global widget
global var
global Property

#
# get colors 
#
set colors [ GetColorDepth ]

catch { set mode [ exec $var(Xinfo) -m ] }

set resolution [ lindex $mode 0 ]

set DCF [ lindex $mode 1 ]
set HFL [ lindex $mode 5 ]
set VFL [ lindex $mode 9 ]

catch { set Horizontal [ expr $DCF / $HFL.0 ] }
catch { set Vertical   [ expr int ( ( $Horizontal \* 1e6 ) / $VFL ) ] }
catch { set Horizontal [ expr int ( $Horizontal \* 1000 ) ] }

set text "$resolution  \[ $Horizontal Khz : $Vertical Hz \]  in $colors Bit"
#puts $text

if { $Property == "desktop" } {
 $widget(InfoMessage) configure -text "Desktop $text"
} else {
 $widget(InfoMessage) configure -text "Modeline $mode"
}
}

proc SetNls {} {
#####--SetNls--#######
# This function set language to all widgets
#
#---------------#
# variables     #
#---------------#
global nlstype
global var
global widget
global nls

foreach alias [ array names nlstype ] {
 set winexist "-1"
 catch { set winexist [ winfo exists $widget($alias) ] }

 if { $winexist } {
   SetNlstext $alias
 }
}
}

proc SetNlstext {alias} {
#####--SetNlstext--#######
# This function set the text according to language
# to a widget specified by "alias"
#
#-------------#
# Variables   #
#-------------#
global var 
global nls 
global nlstype 
global widget

set text ""
catch { set text $nls($var(lang),$nlstype($alias)) }

if { $text == "" } {
 #puts "fault: $alias"
 return "-1"
}

#
# set real text without the 
# accelerator "&" mark
#
set accel  ""
set under [ string first "&" $text ]

if { $under != -1 } {

  set before ""
  set after  ""
  if [ regexp -- {(.*)&(.)(.*)} $text dummy before accel after ] {
    set text "$before$accel$after"
    set accel [ string tolower $accel ]
  }
        
}

#
# find out which classtype is the 
# widget, then set the text
#
set class ""
catch { set class [ winfo class $widget($alias) ] }

switch $class {

   Label {

     $widget($alias) configure -text "$text"

    }

   Menubutton {

    #
    # Set the menu main name 
    #
    $widget($alias) configure  -text "$text"
    if { $under != -1 } {
     $widget($alias) configure -underline $under
    }
   
    #
    # Set the single entries    
    #
    set mname ""
    set mb $alias
    #puts $mb

    set m [ $widget($mb) cget -menu ]
    set num [ $m index last ]

    regsub -- Menu $mb "" mname

    set j 0
    for { set i 0 } { $i <= $num } { incr i } {

     if { [ $m type $i ] == "separator" } {
       continue
     }

     $m entryconfigure $i   -label "$nls($var(lang),menu_[string tolower $mname]_$j)"
     #puts "menu_[string tolower $mname]_$j"
     incr j
    }

   }
 
   Button -
   Radiobutton - 
   Checkbutton { 
            
    $widget($alias) configure  -text "$text" 
    if { $under != -1 } {
     $widget($alias) configure -underline $under
    }

   }


   Scale -
   TixLabelFrame -
   TixControl {
   
     $widget($alias) configure -label "$text"
     update

   }

   Toplevel {

     wm title $widget($alias) "$text"

   }

   default {

   } 

}
}

proc SetXfineMode {} {
####--SetXfineMode--#########
# set the xfine mode to "configure a modi return to sax"
# or                    "configure mode and exit"
#
#-----------#
# variables #
#-----------#
global var
global widget

if { $var(XfineMode) == "normal" } {
 return "normal"
}

set m [ $widget(MenuOptions) cget -menu ] 
$m entryconfigure 0 -state disabled

$widget(BtnSave) configure -command {

  global var

  catch { set mode [ exec $var(Xinfo) -m ] }
  set res [ lrange $mode 0 0 ]
  set res [ string trim $res {"} ]
  set res [ string trim $res ]
  set file $var(SaxTmp)[set res] 
  SaveMode $file
  set var(ReturnValue) "2"

  set handle [ open $var(XfineReturn) "w" ]
  puts $handle $var(ReturnValue)
  close $handle

  exit 0

}
}

proc StepBig {} {
global upstep 
global downstep
global leftstep
global rightstep
global upsize 
global downsize
global leftsize
global rightsize

set upstep    "12"
set downstep  "12"
set leftstep  "32"
set rightstep "32"
set upsize    "32" 
set downsize  "32" 
set leftsize  "32"
set rightsize "32"
}

proc StepNormal {} {
global upstep 
global downstep
global leftstep
global rightstep
global upsize 
global downsize
global leftsize
global rightsize

set upstep    "9"
set downstep  "9"
set leftstep  "16"
set rightstep "16"
set upsize    "16" 
set downsize  "16" 
set leftsize  "16"
set rightsize "16"
}

proc StepSmall {} {
global upstep 
global downstep
global leftstep
global rightstep
global upsize 
global downsize
global leftsize
global rightsize

set upstep    "6"
set downstep  "6"
set leftstep  "8"
set rightstep "8"
set upsize    "8" 
set downsize  "8" 
set leftsize  "8"
set rightsize "8"
}

proc TestTmpDir {} {
#------------#
# variables  #
#------------#
global var

if { [ file isdirectory $var(SaxTmp) ] == 0 } {
 catch { exec rm -f $var(SaxTmp) }
 catch { exec mkdir $var(SaxTmp) }
}
catch { exec rm -f $var(Changed) }
#set chmod_dir [ catch {eval {exec chmod 755 $var(TmpSax)} } ]
#if { $chmod_dir != 0 } {
# puts "I'm not owning $var(SaxTmp) - aborting for security reasons."
# exit 1
#}

#------------------#
# init return file #
#------------------#
set handle [ open $var(XfineReturn) "w" ]
puts $handle "1"
close $handle
}

proc main {argc argv} {
#-------------------#
# test on root user #
#-------------------#
ProveOnRoot

#---------------#
# test tmp dir  #
#---------------#
TestTmpDir

#-----------#
# set modus #
#-----------#
#SetXfineMode

#-----------------#
# set status info # 
#-----------------#
global Property 
set Property "desktop"
SetInfo

#-------------#
# get options #
#-------------#
global OptionList
global var
global widget
GetOptions OptionList 

if { $OptionList(-l) != "" } {
 switch $OptionList(-l) {

   "de"    { set var(lang) "de" }
   "en"    { set var(lang) "en" }
   "fr"    { set var(lang) "fr" }
   "it"    { set var(lang) "it" }
   "es"    { set var(lang) "es" }
   "pt_BR" { set var(lang) "pt_BR" }
   "br"    { set var(lang) "br" }
   "nl"    { set var(lang) "nl" }
   "hu"    { set var(lang) "hu" }
   "pl"    { set var(lang) "pl" }
   "pt"    { set var(lang) "pt" }
   "sk"    { set var(lang) "sk" }
   "ro"    { set var(lang) "ro" }
   "el"    { set var(lang) "el" }
   "id"    { set var(lang) "id" }
   "ru"    { set var(lang) "ru" }
   "tr"    { set var(lang) "tr" }
   "sv"    { set var(lang) "sv" }     
   "cs"    { set var(lang) "cs" }
   "ca"    { set var(lang) "ca" }
   default { set var(lang) "en" }

 }
} 

#----------------------------#
# store display information  #
#----------------------------#
GetHdisp var(Hdisp) var(Hsyncstart) var(Hsyncend) var(Htotal)
GetVdisp var(Vdisp) var(Vsyncstart) var(Vsyncend) var(Vtotal)

#-------------------------#
# set the position to the # 
# center                  #
#-------------------------#
wm geometry $widget(Xfine) 600x350+$var(Xpos)+$var(Ypos)
focus -force $widget(Xfine)
wm geometry $widget(TopCurrent) +0+0

#----------------#
# init widgets   #
#----------------#
global Stepsize
global Property
set Stepsize "Small"
set Property "desktop"
InitAllWidgets

#------------------#
# set the language #
#------------------#
InitNlstype
InitNlstext
SetNls

#------------------------#
# set the arrow pictures #
#------------------------#
global widget

$widget(BtnPosUp)     configure -image [ image create pixmap -file $var(PixmapPath)kvidtune-up.xpm ]
$widget(BtnPosDown)   configure -image [ image create pixmap -file $var(PixmapPath)kvidtune-down.xpm ]
$widget(BtnPosLeft)   configure -image [ image create pixmap -file $var(PixmapPath)kvidtune-left.xpm ]
$widget(BtnPosRight)  configure -image [ image create pixmap -file $var(PixmapPath)kvidtune-right.xpm ]
$widget(BtnSizeUp)    configure -image [ image create pixmap -file $var(PixmapPath)kvidtune-taller.xpm ]
$widget(BtnSizeDown)  configure -image [ image create pixmap -file $var(PixmapPath)kvidtune-shorter.xpm ]
$widget(BtnSizeLeft)  configure -image [ image create pixmap -file $var(PixmapPath)kvidtune-narrower.xpm ]
$widget(BtnSizeRight) configure -image [ image create pixmap -file $var(PixmapPath)kvidtune-wider.xpm ]
}

proc Window {args} {
global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    wm focusmodel $base passive
    wm geometry $base 1x1+0+0
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm withdraw $base
    wm title $base "vt.tcl"
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.top30 {base} {
    if {$base == ""} {
        set base .top30
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 600x59+257+189
    wm maxsize $base 1585 1170
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Desktop Information"
    frame $base.fra31 \
        -borderwidth 5 -height 75 -relief ridge -width 125 
    frame $base.fra31.fra33 \
        -borderwidth 4 -height 75 -width 125 
    message $base.fra31.fra33.mes34 \
        -borderwidth 1 \
        -font -*-Helvetica-medium-R-Normal--*-140-*-*-*-*-*-* -padx 30 \
        -pady 2 -relief sunken \
        -text {Desktop 1600x1200  [ 93 Khz : 74 Hz ]  in 24 Bit} -width 1000 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra31 \
        -in .top30 -anchor center -expand 1 -fill both -side top 
    pack $base.fra31.fra33 \
        -in .top30.fra31 -anchor center -expand 1 -fill both -side top 
    pack $base.fra31.fra33.mes34 \
        -in .top30.fra31.fra33 -anchor center -expand 1 -fill both -side top 
}

proc vTclWindow.top34 {base} {
    if {$base == ""} {
        set base .top34
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 550x350+444+297
    wm maxsize $base 1137 834
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Xfine"
    frame $base.fra35 \
        -borderwidth 5 -height 75 -relief ridge -width 125 
    frame $base.fra35.fra36 \
        -borderwidth 8 -height 75 -width 125 
    frame $base.fra35.fra36.fra39 \
        -borderwidth 1 -height 75 -relief raised -width 125 
    frame $base.fra35.fra36.fra39.fra42 \
        -borderwidth 4 -height 75 -width 125 
    menubutton $base.fra35.fra36.fra39.fra42.men44 \
        -menu .top34.fra35.fra36.fra39.fra42.men44.m -padx 4 -pady 3 \
        -text Schrittweite 
    menu $base.fra35.fra36.fra39.fra42.men44.m \
        -cursor {} -tearoff 0 
    $base.fra35.fra36.fra39.fra42.men44.m add radiobutton \
        \
        -command {#-----------#
# variables #
#-----------#
global widget

#
# set step
#
StepSmall


$widget(BtnSizeLeft) configure -state normal
$widget(BtnSizeRight) configure -state normal
$widget(BtnSizeUp) configure -state normal
$widget(BtnSizeDown) configure -state normal

$widget(BtnPosUp) configure -state normal
$widget(BtnPosDown) configure -state normal
$widget(BtnPosLeft) configure -state normal
$widget(BtnPosRight) configure -state normal} \
        -label {Kleine Schrittweite} -value Small -variable Stepsize 
    $base.fra35.fra36.fra39.fra42.men44.m add radiobutton \
        \
        -command {#-----------#
# variables #
#-----------#
global widget

#
# set step
#
StepNormal


$widget(BtnSizeLeft) configure -state normal
$widget(BtnSizeRight) configure -state normal
$widget(BtnSizeUp) configure -state normal
$widget(BtnSizeDown) configure -state normal

$widget(BtnPosUp) configure -state normal
$widget(BtnPosDown) configure -state normal
$widget(BtnPosLeft) configure -state normal
$widget(BtnPosRight) configure -state normal} \
        -label {Normale Schrittweite} -value Normal -variable Stepsize 
    $base.fra35.fra36.fra39.fra42.men44.m add radiobutton \
        \
        -command {#-----------#
# variables #
#-----------#
global widget

#
# set step
#
StepBig


$widget(BtnSizeLeft) configure -state normal
$widget(BtnSizeRight) configure -state normal
$widget(BtnSizeUp) configure -state normal
$widget(BtnSizeDown) configure -state normal

$widget(BtnPosUp) configure -state normal
$widget(BtnPosDown) configure -state normal
$widget(BtnPosLeft) configure -state normal
$widget(BtnPosRight) configure -state normal} \
        -label {Groe Schrittweite} -value Big -variable Stepsize 
    menubutton $base.fra35.fra36.fra39.fra42.men47 \
        -menu .top34.fra35.fra36.fra39.fra42.men47.m -padx 4 -pady 3 \
        -text Optionen 
    menu $base.fra35.fra36.fra39.fra42.men47.m \
        -cursor {} -tearoff 0 
    $base.fra35.fra36.fra39.fra42.men47.m add radiobutton \
        -command SetInfo -label {Zeige aktuelle Desktop Eigenschaften} \
        -value desktop -variable Property 
    $base.fra35.fra36.fra39.fra42.men47.m add radiobutton \
        -command SetInfo -label {Zeige aktuelle Modeline} -value modeline \
        -variable Property 
    frame $base.fra35.fra37 \
        -borderwidth 8 -height 75 -width 125 
    tixLabelFrame $base.fra35.fra37.tix50 \
        -label Gre -borderwidth 5 -height 10 -width 7 
    frame $base.fra35.fra37.tix50.border.frame.fra52 \
        -borderwidth 4 -height 75 -width 125 
    pack $base.fra35.fra37.tix50.border.frame.fra52 \
        -in .top34.fra35.fra37.tix50.border.frame -anchor center -expand 1 \
        -fill both -side top 
    frame $base.fra35.fra37.tix50.border.frame.fra52.fra64 \
        -borderwidth 2 -height 30 -width 30 
    grid $base.fra35.fra37.tix50.border.frame.fra52.fra64 \
        -in .top34.fra35.fra37.tix50.border.frame.fra52 -column 0 -row 2 \
        -columnspan 1 -rowspan 1 
    frame $base.fra35.fra37.tix50.border.frame.fra52.fra65 \
        -borderwidth 2 -height 75 -width 125 
    grid $base.fra35.fra37.tix50.border.frame.fra52.fra65 \
        -in .top34.fra35.fra37.tix50.border.frame.fra52 -column 0 -row 3 \
        -columnspan 1 -rowspan 1 
    button $base.fra35.fra37.tix50.border.frame.fra52.fra65.but77 \
        \
        -command {#------------------#
# change size left #
#------------------#
global leftsize
global var
global widget
set error "1"

GetVdisp vdisp vsyncstart vsyncend vtotal
GetHdisp hdisp hsyncstart hsyncend htotal

set htotal [ expr $htotal + $upsize ]
#
# prove the values
# if we can set them to the server
#
set error [ EvaluateMaxFreq $htotal $vtotal ]
if { $error == "-1" } {
 return 
}

#
# set new mode
#
set error [ catch { exec $var(Xinfo) -s $hdisp $hsyncstart $hsyncend $htotal $vdisp $vsyncstart $vsyncend $vtotal } ]
if { $error != "0" } {
 $widget(BtnSizeLeft) configure -state disabled
} else {
 $widget(BtnSizeLeft) configure -state normal
 $widget(BtnSizeRight) configure -state normal
}
SetInfo} \
        -padx 9 -pady 3 -text L 
    grid $base.fra35.fra37.tix50.border.frame.fra52.fra65.but77 \
        -in .top34.fra35.fra37.tix50.border.frame.fra52.fra65 -column 0 \
        -row 0 -columnspan 1 -rowspan 1 
    frame $base.fra35.fra37.tix50.border.frame.fra52.fra66 \
        -borderwidth 2 -height 30 -width 30 
    grid $base.fra35.fra37.tix50.border.frame.fra52.fra66 \
        -in .top34.fra35.fra37.tix50.border.frame.fra52 -column 0 -row 4 \
        -columnspan 1 -rowspan 1 
    frame $base.fra35.fra37.tix50.border.frame.fra52.fra67 \
        -borderwidth 2 -height 75 -width 125 
    grid $base.fra35.fra37.tix50.border.frame.fra52.fra67 \
        -in .top34.fra35.fra37.tix50.border.frame.fra52 -column 1 -row 2 \
        -columnspan 1 -rowspan 1 
    button $base.fra35.fra37.tix50.border.frame.fra52.fra67.but78 \
        \
        -command {#----------------#
# change size up #
#----------------#
global upsize
global var
global widget
set error "1"

GetVdisp vdisp vsyncstart vsyncend vtotal
GetHdisp hdisp hsyncstart hsyncend htotal

set vtotal [ expr $vtotal - $upsize ]
#
# prove the values
# if we can set them to the server
#
set error [ EvaluateMaxFreq $htotal $vtotal ]
if { $error == "-1" } {
 return 
}

#
# set new mode
#
set error [ catch { exec $var(Xinfo) -s $hdisp $hsyncstart $hsyncend $htotal $vdisp $vsyncstart $vsyncend $vtotal } ]
if { $error != "0" } {
 $widget(BtnSizeUp) configure -state disabled
} else {
 $widget(BtnSizeUp) configure -state normal
 $widget(BtnSizeDown) configure -state normal
}
SetInfo} \
        -padx 9 -pady 3 -state active -text U 
    grid $base.fra35.fra37.tix50.border.frame.fra52.fra67.but78 \
        -in .top34.fra35.fra37.tix50.border.frame.fra52.fra67 -column 0 \
        -row 0 -columnspan 1 -rowspan 1 
    frame $base.fra35.fra37.tix50.border.frame.fra52.fra68 \
        -borderwidth 2 -height 30 -width 30 
    grid $base.fra35.fra37.tix50.border.frame.fra52.fra68 \
        -in .top34.fra35.fra37.tix50.border.frame.fra52 -column 2 -row 2 \
        -columnspan 1 -rowspan 1 
    frame $base.fra35.fra37.tix50.border.frame.fra52.fra70 \
        -borderwidth 2 -height 75 -width 125 
    grid $base.fra35.fra37.tix50.border.frame.fra52.fra70 \
        -in .top34.fra35.fra37.tix50.border.frame.fra52 -column 2 -row 3 \
        -columnspan 1 -rowspan 1 
    button $base.fra35.fra37.tix50.border.frame.fra52.fra70.but80 \
        \
        -command {#-------------------#
# change size right #
#-------------------#
global rightsize
global var
global widget
set error "1"

GetVdisp vdisp vsyncstart vsyncend vtotal
GetHdisp hdisp hsyncstart hsyncend htotal

set htotal [ expr $htotal - $upsize ]
#
# prove the values
# if we can set them to the server
#
set error [ EvaluateMaxFreq $htotal $vtotal ]
if { $error == "-1" } {
 return 
}

#
# set new mode
#
set error [ catch { exec $var(Xinfo) -s $hdisp $hsyncstart $hsyncend $htotal $vdisp $vsyncstart $vsyncend $vtotal } ]
if { $error != "0" } {
 $widget(BtnSizeRight) configure -state disabled
} else {
 $widget(BtnSizeLeft) configure -state normal
 $widget(BtnSizeRight) configure -state normal
}
SetInfo} \
        -padx 9 -pady 3 -text R 
    grid $base.fra35.fra37.tix50.border.frame.fra52.fra70.but80 \
        -in .top34.fra35.fra37.tix50.border.frame.fra52.fra70 -column 0 \
        -row 0 -columnspan 1 -rowspan 1 
    frame $base.fra35.fra37.tix50.border.frame.fra52.fra71 \
        -borderwidth 2 -height 75 -width 125 
    grid $base.fra35.fra37.tix50.border.frame.fra52.fra71 \
        -in .top34.fra35.fra37.tix50.border.frame.fra52 -column 1 -row 4 \
        -columnspan 1 -rowspan 1 
    button $base.fra35.fra37.tix50.border.frame.fra52.fra71.but79 \
        \
        -command {#------------------#
# change size down #
#------------------#
global downsize
global var
global widget
set error "1"

GetVdisp vdisp vsyncstart vsyncend vtotal
GetHdisp hdisp hsyncstart hsyncend htotal

set vtotal [ expr $vtotal + $downsize ]
#
# prove the values
# if we can set them to the server
#
set error [ EvaluateMaxFreq $htotal $vtotal ]
if { $error == "-1" } {
 return 
}

#
# set new mode
#
set error [ catch { exec $var(Xinfo) -s $hdisp $hsyncstart $hsyncend $htotal $vdisp $vsyncstart $vsyncend $vtotal } ]
if { $error != "0" } {
 $widget(BtnSizeDown) configure -state disabled
} else {
 $widget(BtnSizeUp) configure -state normal
 $widget(BtnSizeDown) configure -state normal
}
SetInfo} \
        -padx 9 -pady 3 -text D 
    grid $base.fra35.fra37.tix50.border.frame.fra52.fra71.but79 \
        -in .top34.fra35.fra37.tix50.border.frame.fra52.fra71 -column 0 \
        -row 0 -columnspan 1 -rowspan 1 
    frame $base.fra35.fra37.tix50.border.frame.fra52.fra72 \
        -borderwidth 2 -height 30 -width 30 
    grid $base.fra35.fra37.tix50.border.frame.fra52.fra72 \
        -in .top34.fra35.fra37.tix50.border.frame.fra52 -column 2 -row 4 \
        -columnspan 1 -rowspan 1 
    tixLabelFrame $base.fra35.fra37.tix51 \
        -label Position -borderwidth 5 
    frame $base.fra35.fra37.tix51.border.frame.fra81 \
        -borderwidth 4 -height 75 -width 125 
    grid $base.fra35.fra37.tix51.border.frame.fra81 \
        -in .top34.fra35.fra37.tix51.border.frame -column 0 -row 0 \
        -columnspan 1 -rowspan 1 
    frame $base.fra35.fra37.tix51.border.frame.fra81.01 \
        -borderwidth 2 -height 30 -width 30 
    grid $base.fra35.fra37.tix51.border.frame.fra81.01 \
        -in .top34.fra35.fra37.tix51.border.frame.fra81 -column 0 -row 2 \
        -columnspan 1 -rowspan 1 
    frame $base.fra35.fra37.tix51.border.frame.fra81.02 \
        -borderwidth 2 -height 75 -width 125 
    grid $base.fra35.fra37.tix51.border.frame.fra81.02 \
        -in .top34.fra35.fra37.tix51.border.frame.fra81 -column 0 -row 3 \
        -columnspan 1 -rowspan 1 
    button $base.fra35.fra37.tix51.border.frame.fra81.02.03 \
        \
        -command {#----------------------#
# change position left #
#----------------------#
global leftstep
global var
global widget
set error "1"

GetVdisp vdisp vsyncstart vsyncend vtotal
GetHdisp hdisp hsyncstart hsyncend htotal

set hsyncstart [ expr $hsyncstart + $leftstep ]
set hsyncend   [ expr $hsyncend + $leftstep ]
#
# prove the values
# if we can set them to the server
#
set error [ EvaluateMaxFreq $htotal $vtotal ]
if { $error == "-1" } {
 return 
}

#
# set new mode
#
set error [ catch { exec $var(Xinfo) -s $hdisp $hsyncstart $hsyncend $htotal $vdisp $vsyncstart $vsyncend $vtotal } ]
if { $error != "0" } {
 $widget(BtnPosLeft) configure -state disabled
} else {
 $widget(BtnPosLeft) configure -state normal
 $widget(BtnPosRight) configure -state normal
}
SetInfo} \
        -padx 9 -pady 3 -text L 
    grid $base.fra35.fra37.tix51.border.frame.fra81.02.03 \
        -in .top34.fra35.fra37.tix51.border.frame.fra81.02 -column 0 -row 0 \
        -columnspan 1 -rowspan 1 
    frame $base.fra35.fra37.tix51.border.frame.fra81.04 \
        -borderwidth 2 -height 30 -width 30 
    grid $base.fra35.fra37.tix51.border.frame.fra81.04 \
        -in .top34.fra35.fra37.tix51.border.frame.fra81 -column 0 -row 4 \
        -columnspan 1 -rowspan 1 
    frame $base.fra35.fra37.tix51.border.frame.fra81.05 \
        -borderwidth 2 -height 75 -width 125 
    grid $base.fra35.fra37.tix51.border.frame.fra81.05 \
        -in .top34.fra35.fra37.tix51.border.frame.fra81 -column 1 -row 2 \
        -columnspan 1 -rowspan 1 
    button $base.fra35.fra37.tix51.border.frame.fra81.05.06 \
        \
        -command {#--------------------#
# change position up #
#--------------------#
global upstep
global var
global widget
set error "1"

GetVdisp vdisp vsyncstart vsyncend vtotal
GetHdisp hdisp hsyncstart hsyncend htotal

set vsyncstart [ expr $vsyncstart + $upstep ]
set vsyncend   [ expr $vsyncend + $upstep ]
#
# prove the values
# if we can set them to the server
#
set error [ EvaluateMaxFreq $htotal $vtotal ]
if { $error == "-1" } {
 return 
}

#
# set new mode
#
set error [ catch { exec $var(Xinfo) -s $hdisp $hsyncstart $hsyncend $htotal $vdisp $vsyncstart $vsyncend $vtotal } ]
if { $error != "0" } {
 $widget(BtnPosUp) configure -state disabled
} else {
 $widget(BtnPosUp) configure -state normal
 $widget(BtnPosDown) configure -state normal
}
SetInfo} \
        -padx 9 -pady 3 -text U 
    grid $base.fra35.fra37.tix51.border.frame.fra81.05.06 \
        -in .top34.fra35.fra37.tix51.border.frame.fra81.05 -column 0 -row 0 \
        -columnspan 1 -rowspan 1 
    frame $base.fra35.fra37.tix51.border.frame.fra81.07 \
        -borderwidth 2 -height 30 -width 30 
    grid $base.fra35.fra37.tix51.border.frame.fra81.07 \
        -in .top34.fra35.fra37.tix51.border.frame.fra81 -column 2 -row 2 \
        -columnspan 1 -rowspan 1 
    frame $base.fra35.fra37.tix51.border.frame.fra81.08 \
        -borderwidth 2 -height 75 -width 125 
    grid $base.fra35.fra37.tix51.border.frame.fra81.08 \
        -in .top34.fra35.fra37.tix51.border.frame.fra81 -column 2 -row 3 \
        -columnspan 1 -rowspan 1 
    button $base.fra35.fra37.tix51.border.frame.fra81.08.09 \
        \
        -command {#-----------------------#
# change position right #
#-----------------------#
global rightstep
global var
global widget
set error "1"

GetVdisp vdisp vsyncstart vsyncend vtotal
GetHdisp hdisp hsyncstart hsyncend htotal

set hsyncstart [ expr $hsyncstart - $rightstep ]
set hsyncend   [ expr $hsyncend - $rightstep ]
#
# prove the values
# if we can set them to the server
#
set error [ EvaluateMaxFreq $htotal $vtotal ]
if { $error == "-1" } {
 return 
}

#
# set new mode
#
set error [ catch { exec $var(Xinfo) -s $hdisp $hsyncstart $hsyncend $htotal $vdisp $vsyncstart $vsyncend $vtotal } ]
if { $error != "0" } {
 $widget(BtnPosRight) configure -state disabled
} else {
 $widget(BtnPosLeft) configure -state normal
 $widget(BtnPosRight) configure -state normal
}
SetInfo} \
        -padx 9 -pady 3 -text R 
    grid $base.fra35.fra37.tix51.border.frame.fra81.08.09 \
        -in .top34.fra35.fra37.tix51.border.frame.fra81.08 -column 0 -row 0 \
        -columnspan 1 -rowspan 1 
    frame $base.fra35.fra37.tix51.border.frame.fra81.010 \
        -borderwidth 2 -height 75 -width 125 
    grid $base.fra35.fra37.tix51.border.frame.fra81.010 \
        -in .top34.fra35.fra37.tix51.border.frame.fra81 -column 1 -row 4 \
        -columnspan 1 -rowspan 1 
    button $base.fra35.fra37.tix51.border.frame.fra81.010.011 \
        \
        -command {#----------------------#
# change position down #
#----------------------#
global downstep
global var
global widget
set error "1"

GetVdisp vdisp vsyncstart vsyncend vtotal
GetHdisp hdisp hsyncstart hsyncend htotal

set vsyncstart [ expr $vsyncstart - $downstep ]
set vsyncend   [ expr $vsyncend - $downstep ]
#
# prove the values
# if we can set them to the server
#
set error [ EvaluateMaxFreq $htotal $vtotal ]
if { $error == "-1" } {
 return 
}

#
# set new mode
#
set error [ catch { exec $var(Xinfo) -s $hdisp $hsyncstart $hsyncend $htotal $vdisp $vsyncstart $vsyncend $vtotal } ]
if { $error != "0" } {
 $widget(BtnPosDown) configure -state disabled
} else {
 $widget(BtnPosUp) configure -state normal
 $widget(BtnPosDown) configure -state normal
}
SetInfo} \
        -padx 9 -pady 3 -text D 
    grid $base.fra35.fra37.tix51.border.frame.fra81.010.011 \
        -in .top34.fra35.fra37.tix51.border.frame.fra81.010 -column 0 -row 0 \
        -columnspan 1 -rowspan 1 
    frame $base.fra35.fra37.tix51.border.frame.fra81.012 \
        -borderwidth 2 -height 30 -width 30 
    grid $base.fra35.fra37.tix51.border.frame.fra81.012 \
        -in .top34.fra35.fra37.tix51.border.frame.fra81 -column 2 -row 4 \
        -columnspan 1 -rowspan 1 
    frame $base.fra35.fra37.fra35 \
        -borderwidth 15 -height 75 -width 125 
    button $base.fra35.fra37.fra35.but36 \
        \
        -command {#------------------------------#
# edit code for next mode      #
# here                         #
#------------------------------#
catch { exec $var(Xinfo) -n }
StoreOldMode
SetInfo
} \
        -padx 9 -pady 3 -text {Nchster Mode} 
    button $base.fra35.fra37.fra35.but37 \
        \
        -command {#------------------------------#
# edit code for previous mode  #
# here                         #
#------------------------------#
catch { exec $var(Xinfo) -p }
StoreOldMode
SetInfo
} \
        -padx 9 -pady 3 -text {Vorheriger Mode} 
    button $base.fra35.fra37.fra35.but38 \
        \
        -command {#--------#
# reset  #
#--------#
set error "1"
global var

catch { set mode [ exec $var(Xinfo) -m ] }
set res [ lrange $mode 0 0 ]
set res [ string trim $res {"} ]
set res [ string trim $res ]

set Hdisp       [ lrange $var(Old[set res]) 2 2 ]
set Hsyncstart  [ lrange $var(Old[set res]) 3 3 ]
set Hsyncend    [ lrange $var(Old[set res]) 4 4 ]
set Htotal      [ lrange $var(Old[set res]) 5 5 ]

set Vdisp       [ lrange $var(Old[set res]) 6 6 ]
set Vsyncstart  [ lrange $var(Old[set res]) 7 7 ]
set Vsyncend    [ lrange $var(Old[set res]) 8 8 ]
set Vtotal      [ lrange $var(Old[set res]) 9 9 ]

set error [ catch { exec $var(Xinfo) -s $Hdisp $Hsyncstart $Hsyncend $Htotal $Vdisp $Vsyncstart $Vsyncend $Vtotal } ]
SetInfo} \
        -padx 9 -pady 3 -text Zurcksetzen 
    button $base.fra35.fra37.fra35.but45 \
        -command {#
# code for go back to SaX
#
set var(ReturnValue) "2"

set handle [ open $var(XfineReturn) "w" ]
puts $handle $var(ReturnValue)
close $handle

exit 0
} -padx 9 -pady 3 \
        -text {Zurck zu SaX} 
    button $base.fra35.fra37.fra35.but46 \
        \
        -command {#-----------#
# variables #
#-----------#
global var
global widget

catch { set mode [ exec $var(Xinfo) -m ] }
set res [ lrange $mode 0 0 ]
set res [ string trim $res {"} ]
set res [ string trim $res ]
set file $var(SaxTmp)[set res]
SaveMode $file
set text [ $widget(BtnSaveMode) cget -text ]
foreach i {1 2 3 4} {
 $widget(BtnSaveMode) configure -text ""
 update
 after 100
 $widget(BtnSaveMode) configure -text $text
 update
 after 100
}
global nls
$widget(BtnSaveMode) configure -text $nls($var(lang),is_stored)
update
after 400
$widget(BtnSaveMode) configure -text $text
update
#set var(ReturnValue) "2"

#set handle [ open $var(XfineReturn) "w" ]
#puts $handle $var(ReturnValue)
#close $handle

#exit 0
} \
        -padx 9 -pady 3 -width 16 -text {Modus Speichern} 
    frame $base.fra35.fra38 \
        -borderwidth 8 -height 75 -width 125 
    frame $base.fra35.fra38.fra45 \
        -borderwidth 1 -height 75 -relief raised -width 125 
    frame $base.fra35.fra38.fra45.01 \
        -borderwidth 4 -height 75 -width 125 
    frame $base.fra35.fra38.fra45.01.fra47 \
        -height 75 -width 125 
    button $base.fra35.fra38.fra45.01.fra47.but48 \
        \
        -command {#-----------#
# variables #
#-----------#
global var

set var(ReturnValue) "1"

set handle [ open $var(XfineReturn) "w" ]
puts $handle $var(ReturnValue)
close $handle

exit 0} \
        -padx 9 -pady 3 -text Abbrechen 
    button $base.fra35.fra38.fra45.01.fra47.but30 \
        -command SaveAndExit -padx 9 -pady 3 \
        -text {Konfiguration abschlieen} 
    button $base.fra35.fra38.fra45.01.but38 \
        -borderwidth 0 -padx 9 -pady 3 -relief flat -state disabled \
        -takefocus 0 -width 5 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra35 \
        -in .top34 -anchor center -expand 1 -fill both -side top 
    pack $base.fra35.fra36 \
        -in .top34.fra35 -anchor center -expand 0 -fill both -side top 
    pack $base.fra35.fra36.fra39 \
        -in .top34.fra35.fra36 -anchor center -expand 1 -fill both -side top 
    pack $base.fra35.fra36.fra39.fra42 \
        -in .top34.fra35.fra36.fra39 -anchor center -expand 1 -fill both \
        -side left 
    pack $base.fra35.fra36.fra39.fra42.men44 \
        -in .top34.fra35.fra36.fra39.fra42 -anchor center -expand 0 \
        -fill none -side left 
    pack $base.fra35.fra36.fra39.fra42.men47 \
        -in .top34.fra35.fra36.fra39.fra42 -anchor center -expand 0 \
        -fill none -side left 
    pack $base.fra35.fra37 \
        -in .top34.fra35 -anchor center -expand 1 -fill both -side top 
    pack $base.fra35.fra37.tix50 \
        -in .top34.fra35.fra37 -anchor center -expand 1 -fill both -side left 
    pack $base.fra35.fra37.tix51 \
        -in .top34.fra35.fra37 -anchor center -expand 1 -fill both -side left 
    pack $base.fra35.fra37.fra35 \
        -in .top34.fra35.fra37 -anchor center -expand 1 -fill both -side top 
    pack $base.fra35.fra37.fra35.but36 \
        -in .top34.fra35.fra37.fra35 -anchor center -expand 0 -fill x \
        -side top 
    pack $base.fra35.fra37.fra35.but37 \
        -in .top34.fra35.fra37.fra35 -anchor center -expand 0 -fill x \
        -side top 
    pack $base.fra35.fra37.fra35.but38 \
        -in .top34.fra35.fra37.fra35 -anchor center -expand 0 -fill x \
        -side top 
    pack $base.fra35.fra37.fra35.but45 \
        -in .top34.fra35.fra37.fra35 -anchor center -expand 0 -fill x \
        -side bottom 
    pack $base.fra35.fra37.fra35.but46 \
        -in .top34.fra35.fra37.fra35 -anchor center -expand 0 -fill x \
        -side bottom 
    pack $base.fra35.fra38 \
        -in .top34.fra35 -anchor center -expand 0 -fill both -side top 
    pack $base.fra35.fra38.fra45 \
        -in .top34.fra35.fra38 -anchor center -expand 1 -fill both -side top 
    pack $base.fra35.fra38.fra45.01 \
        -in .top34.fra35.fra38.fra45 -anchor center -expand 1 -fill both \
        -side left 
    pack $base.fra35.fra38.fra45.01.fra47 \
        -in .top34.fra35.fra38.fra45.01 -anchor center -expand 0 -fill none \
        -side right 
    pack $base.fra35.fra38.fra45.01.fra47.but48 \
        -in .top34.fra35.fra38.fra45.01.fra47 -anchor center -expand 0 \
        -fill none -side right 
    pack $base.fra35.fra38.fra45.01.fra47.but30 \
        -in .top34.fra35.fra38.fra45.01.fra47 -anchor center -expand 0 \
        -fill none -side left 
    pack $base.fra35.fra38.fra45.01.but38 \
        -in .top34.fra35.fra38.fra45.01 -anchor center -expand 0 -fill none \
        -side top 
}

Window show .
Window show .top30
Window show .top34

main $argc $argv
